zoj 2563 Long Dominoes

题目大意

  用1*3的骨牌覆盖一个n*m的矩阵,求方案数。

分析

  m大小为9,状态压缩dp的标志,1*3的骨牌与上两层有关,故可以用2^18来表示状态,横放或者竖放,算一下时间复杂度 30*9*2^18=300000000,而题目只给了2s,晕,故这个题就是卡这种方法,于是就需要转换一下方法了,还是用状态压缩dp,不过这次改成3进制来表示

  0 表示横放或者竖放的第三个格子

  1 表示竖放的第一个格子

  2 表示竖放的第二个格子

  转移的有三个转移

  对应的上一行格子的数为

  0 表明这一行可以放横,也可以放竖的第一个格子

  1 表明这一行竖的第二个格子

  2 这一行只能放竖的第三个格子

这样程序就不会超时了

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<cstring>
#include<string>
#include<set>
#include<cmath>
#include<stack>
#include<queue>
#include<vector>
#include<algorithm>
#include<sstream>
#define inf 0x3f3f3f3f
#define PI acos(-1.0)
#define eps 1e-6
#define LL long long
#define MEM(a,b) memset(a,b,sizeof(a))
#define PB push_back
#define MK make_pair
#define IN freopen("in.txt","r",stdin);
#define OUT freopen("out.txt","w",stdout);
#define BUG printf("bug************bug************bug\n");

using namespace std;
LL dp[31][20000],P_3[20];
LL n,m,row,state;
int num[20];
void init()
{
     P_3[0]=1;
     for (int i=1;i<20;i++) P_3[i]=P_3[i-1]*3;
     //for (int i=1;i<20;i++) printf("%lld ",P_3[i]); printf("\n");
}
void get_bit()
{
     MEM(num,0);
     int k=0;
     LL ss=state;
     while(ss)
     {
          num[k++]=ss%3;
          ss/=3;
     }
}
void dfs(LL p,LL s)
{
     if (p==m) {dp[row+1][s]+=dp[row][state]; return; }
     if (num[p]==0)
     {
          if (p+2<m && num[p+1]==0 && num[p+2]==0) dfs(p+3,s);
          dfs(p+1,s+P_3[p]);
     }
     if (num[p]==1) dfs(p+1,s+2*P_3[p]);
     if (num[p]==2) dfs(p+1,s);
}
int main()
{
     init();
     while(scanf("%lld%lld",&m,&n)!=EOF && n+m)
     {
          if ((n*m)%3!=0) {printf("0\n"); continue; }
          LL maxn=P_3[m];
          MEM(dp,0);
          dp[0][0]=1;
          for (row=0;row<n;row++)
          {
               for (state=0; state<maxn;state++)
               {
                    if (dp[row][state])
                    {
                         get_bit();
                         dfs(0,0);
                    }
               }
          }
          printf("%lld\n",dp[n][0]);
     }
     return 0;
}
时间: 2024-12-17 17:26:45

zoj 2563 Long Dominoes的相关文章

ZOJ 2563 Long Dominoes(状压DP)

给定一个m*n的方格子,要求用3*1的骨牌去覆盖,骨牌可以用横放或者竖放,问最终有多少种放置方式,将其铺满. 分析:由于最多30行,每行最多9列,所以可以按行来dp,设计每行的状态从而进行转移,考虑每个骨牌放置对下一行的影响,共有0,1,2,3种方式,0对应横放或者竖放时最下面那 个格子,此行对下一行没有影响,1,竖放时第1个,2竖放时第2个,这样进行转移.注意,第i行横放时要求上一行相应位置状态为0. 思路及代码都来自这里,其实不会做这题,看了才了解. 代码: 1 #include <bits

ZOJ 2563 Long Dominoes(状压DP)题解

题意:n*m的格子,用1 * 3的矩形正好填满它,矩形不能重叠,问有几种填法 思路:poj2411进阶版.我们可以知道,当连续两行的摆法确定,那么接下来的一行也确定.当第一行还有空时,这时第三行必须要用3 * 1的去填:当第一行没有空第二行有空时,第三行必须不填:当第一行有空第二行没空,这种不能存在:当前两行没空时,我最多就是填1 * 3的方块. 代码: #include<set> #include<map> #include<cmath> #include<qu

ZOJ Problem Set - 2563 Long Dominoes 【状压dp】

题目:ZOJ Problem Set - 2563 Long Dominoes 题意:给出1*3的小矩形,求覆盖m*n的矩阵的最多的不同的方法数? 分析:有一道题目是1 * 2的,比较火,链接:这里 这个差不多,就是当前行的状态对上一行有影响,对上上一行也有影响.所以 定义状态:dp[i][now][up]表示在第 i 行状态为now ,上一行状态为 up 时的方案数. 然后转移方程:dp[i][now][up] = sum ( dp[i-1][up][uup] ) 前提是合法 合法性的判断是比

zoj zju 2994 Tiling a Grid With Dominoes 状压dp

Tiling a Grid With Dominoes Time Limit: 2 Seconds      Memory Limit: 65536 KB We wish to tile a grid 4 units high and N units long with rectangles (dominoes) 2 units by one unit (in either orientation). For example, the figure shows the five differen

ZOJ 2994 &amp;&amp; HDU 1992 Tiling a Grid With Dominoes (状压DP)

题目链接:HDU 1992 Tiling a Grid With Dominoes 题意:一个4*N的矩形,用1*2的小矩形铺满的方法数是多少. 思路:4*N.只有4行想到状压,dp[i][j]表示前i行状态j的方法数,影响当前行的只有上一行!0成对出现表示横着放,1表示竖着放,所以第一行的状态0.3.9.12.15五种,并且只要上一行是0状态.当前行的状态就为0.3.9.12.15五种可能.还有当前行s1和上一行s2匹配仅当s1==0 || s1==(s2取反),特别注意上一行状态是0110(

图论 500题——主要为hdu/poj/zoj

转自——http://blog.csdn.net/qwe20060514/article/details/8112550 =============================以下是最小生成树+并查集======================================[HDU]1213   How Many Tables   基础并查集★1272   小希的迷宫   基础并查集★1325&&poj1308  Is It A Tree?   基础并查集★1856   More i

概率dp ZOJ 3640

Help Me Escape Time Limit:2000MS     Memory Limit:32768KB     64bit IO Format:%lld & %llu Submit Status Practice ZOJ 3640 Appoint description:  System Crawler  (2014-10-22) Description Background     If thou doest well, shalt thou not be accepted? an

zoj 2156 - Charlie&#39;s Change

题目:钱数拼凑,面值为1,5,10,25,求组成n面值的最大钱币数. 分析:dp,01背包.需要进行二进制拆分,否则TLE,利用数组记录每种硬币的个数,方便更新. 写了一个 多重背包的 O(NV)反而没有拆分快.囧,最后利用了状态压缩优化 90ms: 把 1 cents 的最后处理,其他都除以5,状态就少了5倍了. 说明:貌似我的比大黄的快.(2011-09-26 12:49). #include <stdio.h> #include <stdlib.h> #include <

ZOJ 1718 POJ 2031 Building a Space Station 修建空间站 最小生成树 Kruskal算法

题目链接:ZOJ 1718 POJ 2031 Building a Space Station 修建空间站 Building a Space Station Time Limit: 2 Seconds      Memory Limit: 65536 KB You are a member of the space station engineering team, and are assigned a task in the construction process of the statio